#include "str8.h"
#include "aliases.h"
#include <string.h>

c8 wapp_str8_get(const Str8 *str, u64 index) {
  if (index >= str->size) {
    return '\0';
  }

  return str->buf[index];
}

void wapp_str8_set(Str8 *str, u64 index, c8 c) {
  if (index >= str->size) {
    return;
  }

  str->buf[index] = c;
}

i64 wapp_str8_find(Str8RO *str, Str8RO substr) {
  if (substr.size > str->size) {
    return -1;
  }

  for (u64 i = 0; i < str->size; ++i) {
    const c8 *sub = str->buf + i;
    if (memcmp(sub, substr.buf, substr.size) == 0) {
      return i;
    }
  }

  return -1;
}

i64 wapp_str8_rfind(Str8RO *str, Str8RO substr) {
  if (substr.size > str->size) {
    return -1;
  }

  for (i64 i = str->size - substr.size; i >= 0; --i) {
    const c8 *sub = str->buf + i;
    if (memcmp(sub, substr.buf, substr.size) == 0) {
      return i;
    }
  }

  return -1;
}
